; ALAHA (Sacred Unity) (2017) for realtime Csound5/6 - by Arthur B. Hunkins
;  requires a MIDI device with 12 knobs/sliders
;   Set all sliders to 0 prior to Start.
;   If audio glitches occur, reduce the value of sr (Sample Rate,
;    see below) to 44100, 32000, 22050 or even 11025 until glitching disappears.
; See setup/performance instructions in Alaha.txt

<CsoundSynthesizer>
<CsOptions>

; for Windows, Mac
-odac -M0 -m0d --expression-opt -b512 -B2048 -+raw_controller_mode=1
; for Linux
;-odac -+rtaudio=alsa -+rtmidi=alsa -M hw:1,0 -m0d --expression-opt -b128 -B2048 -+raw_controller_mode=1

</CsOptions>
<CsInstruments>

sr = 48000 ; Sample Rate
ksmps = 10
nchnls = 2

#define CHAN	#1# ; 0 = CC7, CHAN 1-12 
#define CTRL1	#20# ; bank1 - first # (of 8) controllers; valid = 0 - 120
#define CTRL2	#28# ; bank2 - first # (of 4) controllers; valid = 0 - 124

	instr 1

 	kamp       ctrl7          ($CHAN = 0? 8: $CHAN), ($CHAN = 0? 7: $CTRL1 + 7), 0, 2000
	kamp	   port	          kamp, .05	
	kfreq      ctrl7	  ($CHAN = 0? 10: $CHAN), ($CHAN = 0? 7: $CTRL2 + 1), 5, 40
	kfreq2	   =	   	  kfreq + 1
	kamp2	   ctrl7	  ($CHAN = 0? 11: $CHAN), ($CHAN = 0? 7: $CTRL2 + 2), 0, 1000
	kamp2	   port	          kamp2, .05	
	kamp3	   ctrl7	  ($CHAN = 0? 12: $CHAN), ($CHAN = 0? 7: $CTRL2 + 3), 0, 1.5
 	k1         ctrl7          ($CHAN = 0? 1: $CHAN), ($CHAN = 0? 7: $CTRL1), 0, .1
	k1	   port	          k1, .05	
	k1a	   jitter	  k1, kfreq, kfreq2
	k2         ctrl7          ($CHAN = 0? 2: $CHAN), ($CHAN = 0? 7: $CTRL1 + 1), 0, .2
	k2	   port	          k2, .05	
	k2a	   jitter	  k2, kfreq, kfreq2
	k3         ctrl7          ($CHAN = 0? 3: $CHAN), ($CHAN = 0? 7: $CTRL1 + 2), 0, .3
	k3	   port	          k3, .05	
	k3a	   jitter	  k3, kfreq, kfreq2
	k4         ctrl7          ($CHAN = 0? 4: $CHAN), ($CHAN = 0? 7: $CTRL1 + 3), 0, .5
	k4	   port	          k4, .05
	k4a	   jitter	  k4, kfreq, kfreq2
	k5         ctrl7          ($CHAN = 0? 5: $CHAN), ($CHAN = 0? 7: $CTRL1 + 4), 0, .7
	k5	   port	          k5, .05
	k5a	   jitter	  k5, kfreq, kfreq2
	k6         ctrl7          ($CHAN = 0? 6: $CHAN), ($CHAN = 0? 7: $CTRL1 + 5), 0, .85
	k6	   port	          k6, .05
	k6a	   jitter	  k6, kfreq, kfreq2
	k7         ctrl7          ($CHAN = 0? 7: $CHAN), ($CHAN = 0? 7: $CTRL1 + 6), 0, .75
	k7	   port	          k7, .05
	k7a	   jitter	  k7, kfreq, kfreq2
	k8         ctrl7          ($CHAN = 0? 9: $CHAN), ($CHAN = 0? 7: $CTRL2), 0, 1
	ax	   poscil	  1, 256, 1
	ay         chebyshevpoly  ax, 0, 0, 0, 0, k1+(k1a*k8), -(k2+(k2a*k8)), -(k3+(k3a*k8)), k4+(k4a*k8), k5+(k5a*k8), -(k6+(k6a*k8)), -(k7+(k7a*k8))
	ay	   =	          ay * kamp
	krand	   jspline	  .6, 3, 4
	krand2	   jitter	  .1, 8, 9
	ay2	   gbuzz	  kamp2, 256 + krand, 30, 10, krand2 + .65, 2
	krand3	   jspline	  .6, 3, 4
	krand4	   jitter	  .1, 8, 9
	ay3	   gbuzz	  kamp2, 256 + krand3, 30, 10, krand4 + .65, 2
	ay4	   reverb	  -ay2 * kamp3, .001
	ay5	   reverb	  -ay3 * kamp3, .001
	aoutL	   =              ay + (ay2 * .85) + (ay3 * .35) + ay4
	aoutR	   =              -ay + (ay2 * .35) + (ay3 * .85) + ay5
		   outs           aoutL * 3, aoutR * 3

		   endin

</CsInstruments>
<CsScore>

f1 0 32768 10 1
f2 0 16384 11 1
i1 0 3600

e

</CsScore>
</CsoundSynthesizer>
