; ALAHA (Sacred Unity) (2017) for realtime Csound6 - by Arthur B. Hunkins
; Requires Android OS 4.1.1 or higher, and Csound6b or Csound6c.apk
;   Downloadable from http://www.arthunkins.com/Android_Csound_Apps.htm
;   Disable WiFi and other connections for maximum performance
;   Run Csound6b/Csound6c, and Browse to (Open) this file
;   If audio glitches remain, reduce the value of sr (Sample Rate,
;    see below) to 44100, 32000, 22050 or even 11025 until glitching disappears.
;   Set all sliders to 0 prior to Start.
; See further information in Alaha.txt
<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr = 48000 ; Sample Rate
ksmps = 10
nchnls = 2

	instr 1

 	kamp       chnget         "slider8"
	kamp	   port	          kamp * 2000, .05	
 	kfreq      chnget         "slider10"
        kfreq	   =		  (kfreq * 35) + 5
	kfreq2	   =	   	  kfreq + 1
 	kamp2      chnget         "slider11"
	kamp2	   port	          kamp2 * 1000, .05	
	kamp3	   chnget	  "slider12"
	kamp3	   =	 	  kamp3 * 1.5
 	k1         chnget         "slider1"
	k1	   port	          k1 * .1, .05	
	k1a	   jitter	  k1, kfreq, kfreq2
	k2         chnget	  "slider2"
	k2	   port	          k2 * .2, .05	
	k2a	   jitter	  k2, kfreq, kfreq2
	k3         chnget	  "slider3"
	k3	   port	          k3 * .3, .05	
	k3a	   jitter	  k3, kfreq, kfreq2
	k4         chnget	  "slider4"
	k4	   port	          k4 * .5, .05
	k4a	   jitter	  k4, kfreq, kfreq2
	k5         chnget	  "slider5"
	k5	   port	          k5 * .7, .05
	k5a	   jitter	  k5, kfreq, kfreq2
	k6         chnget	  "slider6"
	k6	   port	          k6 * .85, .05
	k6a	   jitter	  k6, kfreq, kfreq2
	k7         chnget	  "slider7"
	k7	   port	          k7 * .75, .05
	k7a	   jitter	  k7, kfreq, kfreq2
	k8         chnget	  "slider9"
	ax	   poscil	  1, 256, 1
	ay         chebyshevpoly  ax, 0, 0, 0, 0, k1+(k1a*k8), -(k2+(k2a*k8)), -(k3+(k3a*k8)), k4+(k4a*k8), k5+(k5a*k8), -(k6+(k6a*k8)), -(k7+(k7a*k8))
	ay	   =	          ay * kamp
	krand	   jspline	  .6, 3, 4
	krand2	   jitter	  .1, 8, 9
	ay2	   gbuzz	  kamp2, 256 + krand, 30, 10, krand2 + .65, 2
	krand3	   jspline	  .6, 3, 4
	krand4	   jitter	  .1, 8, 9
	ay3	   gbuzz	  kamp2, 256 + krand3, 30, 10, krand4 + .65, 2
	ay4	   reverb	  -ay2 * kamp3, .001
	ay5	   reverb	  -ay3 * kamp3, .001
	aoutL	   =              ay + (ay2 * .85) + (ay3 * .35) + ay4
	aoutR	   =              -ay + (ay2 * .35) + (ay3 * .85) + ay5
		   outs           aoutL * 3, aoutR * 3

		   endin

</CsInstruments>
<CsScore>

f1 0 32768 10 1
f2 0 16384 11 1
i1 0 3600

e

</CsScore>
</CsoundSynthesizer>
